/* ************************************************************************** */
/*                                       _____           _                    */
/*  libp7/stream.h                      |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libp7                      | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2017/01/04 15:01:48                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#ifndef LIBP7_STREAM_H
# define LIBP7_STREAM_H
# ifdef __cplusplus
extern "C" {
# endif

/*	This file is there so you can implement your own custom protocol instead
 *	of CASIO's Protocol 7 to communicate with a CASIO calculator, while
 *	using libp7 utilities to look for the calculator. */
/* ************************************************************************** */
/*  Stream utilities                                                          */
/* ************************************************************************** */
/* reference to the stream type */
struct p7_stream_s;
typedef struct p7_stream_s p7_stream_t;

/* get the stream from the handle */
const p7_stream_t *p7_get_stream(p7_handle_t *handle);

/* read and write data from and to stream */
int p7_read(p7_stream_t *stream, void *dest, size_t size, unsigned int timeout);
int p7_write(p7_stream_t *stream, const void *data, size_t size);

# ifdef __cplusplus
}
# endif
#endif /* LIBP7_STREAM_H */
